#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "nvs_flash.h"
#include "nvs.h"
#include "esp_log.h"
extern uint8_t MyFile_bin_start[] asm("_binary_MyFile_bin_start");
int cnt=0;
void app_main(void)
{
// Initialize NVS
	esp_err_t err = nvs_flash_init();
	if (err == ESP_ERR_NVS_NO_FREE_PAGES || err == ESP_ERR_NVS_NEW_VERSION_FOUND)
	{
		ESP_ERROR_CHECK(nvs_flash_erase());
		err = nvs_flash_init();
	}
	ESP_ERROR_CHECK(err);
	vTaskDelay(20 / portTICK_PERIOD_MS);
    nvs_handle_t nvs_handle;

	// Open NVS handle
	err = nvs_open("nvs", NVS_READWRITE, &nvs_handle);
	if (err != ESP_OK)
	{
		ESP_LOGI("MyLog", "Error (%s) opening write NVS handle!\n", esp_err_to_name(err));
		return;
	}

    // Read array from NVS under the provided key
	size_t required_size = 1 * sizeof(int);
	err = nvs_get_blob(nvs_handle, "cntData", &cnt, &required_size);
	if (err == ESP_OK)
	{
		ESP_LOGI("MyLog", "Array for key cntData retrieved successfully!\n");
		// for (int i = 0; i < size; i++) {
		//     ESP_LOGI("MyLog","Array[%d] = %d\n", i, arr[i]);
		// }
	}
	else
	{
		ESP_LOGI("MyLog", "Error (%s) reading key %s!\n", esp_err_to_name(err), "cntData");
	}

    cnt++;
	// Write array to NVS under the provided key
	err = nvs_set_blob(nvs_handle, "cntData", &cnt, required_size);
	if (err != ESP_OK)
	{
		ESP_LOGI("MyLog", "Error (%s) writing to key %s!\n", esp_err_to_name(err), "cntData");
	}

	// Commit write
	err = nvs_commit(nvs_handle);
	if (err != ESP_OK)
	{
		ESP_LOGI("MyLog", "Error (%s) committing!\n", esp_err_to_name(err));
	}

	// Close NVS handle
	nvs_close(nvs_handle);

    ESP_LOGI("MyLog", "Cnt value: %d", cnt);
    cnt = MyFile_bin_start[0];
}
